/*↓↓↓↓  页面基础组件  ↓↓↓↓*/
var UILoading;//加载等待组件
var dialogBox;//alert 多功能弹窗
var selectFile;//文件选择器
var UIAlbumBrowser;//图片选择器
var bMap;//百度地图
var sharedModule;//原生分享
var browser;//浏览器
var  pedometer  ;//计步器
var ffPlayer  ;//视频流
var daniuPlayer ;

/*  ↓↓↓↓   api  预加载模块    在  apiready = function () {} 中    调  执行 ↓↓↓↓ */
var apiModelStore = {
    /**
     * 手机内置信息
     */
    apiMobileInfo: function () {
        this.data = {
            //引擎版本信息
            appVersion: api.version,
            //系统类型
            appSystemType: api.systemType,
            //系统版本
            appSystemVersion: api.systemVersion,
            //设备标识
            appDeviceId: api.deviceId,
            //设备型号
            appDeviceModel: api.deviceModel,
            //设备名称
            appDeviceName: api.deviceName,
            //网络状态
            appConnectionType: api.connectionType,

            //屏幕分辨率宽，数字类型
            appScreenWidth: api.screenWidth,
            //屏幕分辨率高，数字类型
            appScreenHeight: api.screenHeight,
            //win 宽
            appWinWidth: api.winWidth,
            //win 高
            appWinHeight: api.winHeight,
            //win name
            appWinName: api.winName,
            //frame name
            appFrameName: api.frameName,
        };
        return this.data
    },

    /*模块商店的应用
    * 使用前必须去商店勾选该组件
    * */

    modelStoreRequire: function () {
        //dark //状态栏字体为黑色，适用于浅色背景
        //light //状态栏字体为白色，适用于深色背景
        // color:'#3285fd'
        api.setStatusBarStyle({
            style: 'light',
            color: '#3285fd'
        });
        //api.parseTapmode();
        UILoading = api.require('UILoading');
        dialogBox = api.require('dialogBox');
        selectFile = api.require('selectFile');
        UIAlbumBrowser = api.require('UIAlbumBrowser');
        bMap = api.require('bMap');
        sharedModule = api.require('shareAction');
        browser = api.require('webBrowser');
        pedometer = api.require('pedometer');

        ffPlayer = api.require('ffPlayer');
        // daniuPlayer = api.require('daniuPlayer')
    },
    /**
     *
     */
    permissions: function (key) {
        /**
         * 判断是否有权限
         * @returns {*}
         * @constructor
         */
        this.myArray = [key] || appConfig.dynamicPermissions;
        this.HasPermission = function (callback) {
            this.result = api.hasPermission({list: this.myArray})[0];
            if (this.result.granted) {
                //todo  有权限 实现业务 返回 true
                callback(true);
            } else {
                var _this = this;
                _this.RequestPermission(function (ret) {
                    callback(ret.granted);
                });
            }
        };
        this.RequestPermission = function (callback) {
            api.requestPermission({
                list: this.myArray,
                code: 100001
            }, function (ret, err) {
                callback(ret.list[0]);
            });
        };
        return this;
    },
    apiIndexOpenWIn: function (winName, url) {
       /* api.closeToWin({
            name: 'index_admin'
        });*/
        api.openWin({
            name: winName,
            url: url,
            reload: true,
            bounces: false,
            slidBackEnabled: false,

        });
    },

    /**
     * 打开 win的方法
     * @param winName
     * @param pageParams
     */
    apiOpenWin: function (winName, pageParams) {

        this.winName = winName + "_win";
        this.url = "widget://html/" + winName + "/" + winName + "_win.html";
        this.pageParams = pageParams || {};
        api.openWin({
            name: this.winName,
            url: this.url,
            bounces: false,
            pageParam: this.pageParams,
            slidBackEnabled: true,
            // slidBackEnabled: winName == "login" ? false : true,
        });

    },

    /**
     * 打开win相对应的frame
     * @param frameName
     * @param pageHeaderFooter
     * @param pageParams
     */
    apiOpenFrame: function (frameName, pageHeaderFooter, pageParams) {

        var bounces = false;
        this.frameName = frameName;
        this.pageHeaderFooter = pageHeaderFooter;
        this.pageParams = pageParams || {};
        if (frameName == "login") {
            bounces=true;
        }
        api.openFrame({
            name: this.frameName,
            url: "widget://html/" + this.frameName + "/" + this.frameName + "_frame.html",
            //url: this.frame.url,
            bounces: bounces,
            animation: {
                type: "none",                //动画类型（详见动画类型常量）

            },
            rect: {
                marginLeft: 0,    //相对父 window 左外边距的距离
                marginTop: this.pageHeaderFooter.headerPosH,    //相对父 window 上外边距的距离
                marginBottom: this.pageHeaderFooter.footerPosH,    //相对父 window 下外边距的距离
                marginRight: 0    //相对父 window 右外边距的距离
            },
            pageParam: this.pageParams,
        });
    },
    /**
     * 打开 ActionSheet
     * @param doWhat
     * @param title
     * @param buttons
     * @param callback
     */
    apiActionSheet: function (doWhat, title, buttons, callback) {
        var _this = this;
        this.title = title;
        this.buttons = buttons;
        if ("changeUserImage" == doWhat) {
            this.title = "修改头像";
            this.buttons = ['拍照', '手机相册'];
        }
        api.actionSheet({
            title: _this.title,
            cancelTitle: '取消',
            buttons: _this.buttons
        }, function (ret, err) {
            callback(ret, err)

        });
    },

    apiConfirm: function (title, msg, callback) {
        api.confirm({
            title: title,
            msg: msg,
            buttons: ['确定', '取消']
        }, function (ret, err) {
            console.log(JSON.stringify(ret));
            var index = ret.buttonIndex;
            callback(index);

        });
    },
    /**
     * 拍照
     * @param callback
     */
    apiGetPicture: function (mediaValue, callback) {
        if(['pic', 'video'].indexOf(mediaValue) == -1){
            mediaValue = 'pic';
        }
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: mediaValue,
            destinationType: 'url',
            allowEdit: true,
            quality: 98,
            videoQuality: 'high',
            targetWidth: 500,
            targetHeight: 500,
            saveToPhotoAlbum: true
        }, function (ret, err) {
            // 获取拍照数据并处理
            callback(ret, err)
        });
    },
    apiToast: function (msg) {
        // $api.toast("title", "content", 2000);
        api.toast({
            msg: msg,
            duration: 2000,
            location: 'middle',
            msgColor: "#D52B2B",
            roundRadius: "100"

        });
    },
    /**返回  关闭当前窗口**/
    goBack: function () {
        setTimeout(function () {
            api.closeWin({});
        }, 500);

    },

    /*关闭popup 界面*/
    closePopup: function () {
        $api.setStorage("popupFrameIsOpen", "close");
        api.closeFrame({
            name: 'popup'
        });
    },

    /**
     * 发送监听
     * @param name
     * @param extraData
     */
    apiSendEvent: function (name, extraData) {
        api.sendEvent({
            name: name,
            extra: extraData || {},
        });
    },
    apiAddEventListener: function (name, callback) {
        api.addEventListener({
            name: name
        }, function (ret, err) {
            callback(ret, err);
        });
    },


    /**
     *
     * @returns {apiModelStore}
     */
    wrFile: function () {

        /**
         **
         * 这个是对文件的读取，path路径支持两种：fs:// 和widget://两种。
         *fs://就是手机SD卡里的UZMap->app id目录
         *widget://就是自己的项目目录，widget目录是只读目录，不可写。
         * @param path
         * @param data
         * @param callback
         */
        this.writeFile = function (path, data, callback) {
            api.writeFile({
                path: path || 'fs://data.json',
                data: JSON.stringify(data),
            }, function (ret, err) {
                callback(ret, err);
                if (ret.status) {
                    // console.log(JSON.stringify(ret))
                } else {
                    // console.log(JSON.stringify(err))
                }
            });
        };
        this.readFile = function (path, callback) {
            api.readFile(
                {
                    path: path || 'fs://data.json'
                },
                function (ret, err) {
                    callback(ret, err);
                    if (ret.status) {

                        // console.log(JSON.stringify(ret))
                    } else {
                        // console.log(JSON.stringify(err))
                        alert('无法读取服务器信息，跳转到服务器配置界面!');
                        //open('setting.html');
                    }
                });
        };


        return this;
    },

    /**
     * 图片选择器
     * @returns {apiModelStore}
     * @constructor
     */
    modelSelectImage: function (max, callback) {
        UIAlbumBrowser.open({
            max: max || 9,
            styles: {
                bg: '#fff',
                mark: {
                    icon: '',
                    position: 'bottom_left',
                    size: 20
                },
                nav: {
                    bg: 'rgba(0,0,0,0.6)',
                    titleColor: '#fff',
                    titleSize: 18,
                    cancelColor: '#fff',
                    cancelSize: 16,
                    finishColor: '#fff',
                    finishSize: 16
                }
            },
            rotation: true
        }, function (ret) {
            if ("cancel" == ret.eventType) {

            } else {
                // myVue.imageFile.imageArr = ret.list;
                // console.log("图片" + JSON.stringify(ret));
                callback(ret);


            }
        });


    },


    /**
     * selectFile 模块内部方法 modelSelectFile  打开
     * @constructor
     */
    modelSelectFile: function () {
        selectFile.open(function (ret, err) {
            if (ret.status) {
                alert(JSON.stringify(ret.path));
            } else {
                alert('选择文件不存在');
            }
        });
    },


    /**
     * 加载进度
     * @returns {apiModelStore}
     */
    loadProgress: function () {
        this.open = function (title, text) {
            api.showProgress({
                animationType: 'zoom',//zoom        fade
                title: title || '努力加载中...',
                text: text || '先喝杯茶...',
                modal: false
            });
        };
        this.close = function () {
            api.hideProgress();
        };
        return this;


    },


    /*UILoading 模块内部方法 fnKeyFrame 打开 */
    fnKeyFrame: function () {
        UILoading.keyFrame({
            rect: {
                w: 80,
                h: 100
            },
            styles: {                       //加载提示框样式配置
                bg: 'rgba(0,5,0,0.5)',      //加载提示框整体背景颜色配置
                corner: 5,                  //背景圆角大小
                interval: 20,               //每帧间隔时长
                frame: {                    //加载框内图标的大小配置
                    w: 80,                  //加载框内图标的宽度
                    h: 80                   //加载框内图标的高度
                }
            },
        }, function (ret) {
            // console.log(ret);
            // console.log(JSON.stringify(ret));
            // console.log(JSON.parse(ret));
        })
    },


    /*UILoading 模块内部方法  fnCloseKeyFrame 关闭*/
    fnCloseKeyFrame: function () {
        UILoading.closeKeyFrame();
    },


    /*dialogBox  模块内部方法 dialogBox_alert1 打开*/
    dialogBox_alert1: function (content, rightString, callBack) {
        dialogBox.alert({
            texts: {
                title: APP.getAppName(),
                content: content || '您当前未登录，是否登录？',
                leftBtnTitle: '取消',
                rightBtnTitle: rightString || "登录"
            },
            styles: {
                bg: '#fff',
                corner: 6,
                w: 260,
                title: {
                    marginT: 20,
                    icon: 'widget://image/dialogBox/gou.png',
                    iconSize: 32,
                    titleSize: 18,
                    titleColor: '#000'
                },
                content: {
                    color: '#000',
                    size: 16
                },
                left: {
                    marginB: 15,
                    marginL: 40,
                    w: 40,
                    h: 35,
                    corner: 2,
                    color: "#000",
                    bg: '#fff',
                    size: 16
                },
                right: {
                    marginB: 15,
                    marginL: 88,
                    w: 40,
                    h: 35,
                    corner: 2,
                    color: "#000",
                    bg: '#fff',
                    size: 16
                }
            },
            tapClose: true
        }, function (ret) {
            if (ret.eventType == 'left') {
                dialogBox.close({
                    dialogName: 'alert'
                });
                callBack("left");
            } else if (ret.eventType == 'right') {
                dialogBox.close({
                    dialogName: 'alert'
                });
                callBack("right");
            }
        });
    },

    keyback: function(){
        api.addEventListener({ 
            name: 'keyback'
        }, function (ret, err) {
            apiModelStore.keybackConfirm();
        });
    },

    keybackConfirm: function(){
        api.confirm({
            title: '确认返回',
            msg: '是否确定退出当前编辑',
            buttons: ['确定', '取消']
        }, function(ret, err) {
            var index = ret.buttonIndex;
            if(index == 1){
                myVue.GoBack();
            }
        });
    }


};
/*  ↑↑↑↑↑↑  api  预加载模块    ↑↑↑↑↑↑ */
