/*↓↓↓↓↓   Vue 配置  ↓↓↓↓↓↓*/
/*设置为 false 以阻止 vue 在启动时生成生产提示*/
//Vue.config.productionTip = false;

/*配置是否允许 vue-devtools 检查代码。开发版本默认为 true，生产版本默认为 false。生产版本设为 true 可以启用检查。*/
//Vue.config.devtools = false;

/* ↑↑↑↑↑↑   Vue 配置  ↑↑↑↑↑↑*/


/*  ↓↓↓↓  APP配置信息  ↓↓↓↓*/
var appConfig = {
    appPageisScrolling:false,
    //app端为false，微信端为true
    isWX: false,
    //true 微信端跨域  用jsonP
    isCrossDomain: false,
    //动态权限 : 相机、通讯录、位置信息、麦克风、电话、短信、存储空间、通知栏
    dynamicPermissions: ["camera", "contacts", "location", "microphone", "phone", "sms", "storage", "notification"],
    appName: "掌上盐池",
    headerPosH: 50,
    footerPosH: 50,
    appFragment: [
        {"titleName": "首页", "frameName": "home"},
        {"titleName": "矩阵", "frameName": "matrix"},
        {"titleName": "消息", "frameName": "message"},
        {"titleName": "我的", "frameName": "my"}
    ],
    version: "1.0.0",
    appID: "A6019775317302",
    author: "Copyright © 2019.Company name All rights reserved.宁夏瑞斯软件有限公司",
    defaultImage: "../../image/nodata.jpg",
    net: {
        // ip: "http://218.95.182.38",
        // port: "28080",
        // ip: "http://192.168.1.177",//ip地址
        // ip: "http://192.168.1.149",//ip地址
        // port: "9003",//端口号/
        // ip: "http://192.168.1.106",// 内网测试地址
        // port: "8003",// 内网测试地址端口号

        // ip: "http://192.168.1.180",// 内网测试地址
        // port: "9003",// 内网测试地址端口号

        //正式地址
        // http://47.92.31.82:20008/zhzlpt,
        // ip: "http://47.92.31.82",// 正式地址
        // port: "20008",// 正式地址端口号
        // ip: "http://218.95.177.2",// 正式地址
        // port: "28090",// 正式地址端口号
        ip: "http://218.95.181.84",// 正式地址s
        port: "28080",// 正式地址端口号
        timeout: 30,//超时时间
        prefix: "/zhzlpt",//前缀
        suffix: "/api/service",//后缀
        suffixJsonp: "/api/jsonpService",//后缀
    },
    //验证配置 字段验证
    validateConfig: {

        smgCode: {
            cValue: "0000",
            dValue: "请输入短信验证码",
            describe: "6位",
            tip: "短信验证码验证失败，不符合要求！",
            state: false
        }, idCard: {
            cValue: "",
            dValue: "请输入身份证号",
            describe: "5-16位",
            tip: "身份证号验证失败，不符合要求！",
            state: false
        }, phone: {
            cValue: "",
            dValue: "请输入手机号",
            describe: "11位",
            tip: "手机号验证失败，不符合要求！",
            state: false
        }, email: {
            cValue: "",
            dValue: "请输入邮箱",
            describe: "格式有误",
            tip: "邮箱验证失败，不符合要求！",
            state: false
        },
        userName: {
            cValue: "",
            dValue: "请输入用户名",
            describe: "5-16位",
            tip: "用户名验证失败，不符合要求！",
            state: false
        },
        passWord: {
            cValue: "",
            dValue: "请输入密码",
            describe: "5-16位",
            tip: "密码验证失败，不符合要求！",
            state: false
        },
        passWordOld: {
            cValue: "",
            dValue: "请输入原密码",
            describe: "5-16位",
            tip: "新密码验证失败，不符合要求！",
            state: false
        },
        passWordNew: {
            cValue: "",
            dValue: "请输入新密码",
            describe: "5-16位",
            tip: "新密码验证失败，不符合要求！",
            state: false
        },
        passWordNewA: {
            cValue: "",
            dValue: "请再输入新密码",
            describe: "5-16位",
            tip: "新密码验证失败，不符合要求！",
            state: false
        },
        imageCode: {
            cValue: "",
            dValue: "请输入图片验证码",
            describe: "5-16位",
            tip: "图片验证码不正确！",
            state: false
        },
        journalTitle: {
            cValue: "",
            dValue: "请输入日志标题",
            describe: "不能为空",
            tip: "标题验证失败，不符合要求（不能含有特殊字符）！",
            state: false
        },
        journalContent: {
            cValue: "",
            dValue: "请输入日志内容",
            describe: "不能为空",
            tip: "内容验证失败，不符合要求（不能含有特殊字符）！",
            state: false
        },
    },
    //宁夏城市id 天气预报
    cityData: {
        "银川市金凤区": {
            id: '101170101',
        }, "银川市西夏区": {
            id: '101170101',
        }, "银川市兴庆区": {
            id: '101170101',
        }, "银川市永宁县": {
            id: '101170102',
        }, "银川市贺兰县": {
            id: '101170104',
        }, "银川市灵武市": {
            id: '101170103',
        }, "石嘴山市平罗县": {
            id: '101170203',
        }, "石嘴山市惠农区": {
            id: '101170202',
        }, "石嘴山市大武口区": {
            id: '101170206',
        }, "吴忠市利通区": {
            id: '101170301',
        }, "吴忠市青铜峡市": {
            id: '101170306',
        }, "吴忠市同心县": {
            id: '101170302',
        }, "吴忠市盐池县": {
            id: '101170303',
        }, "固原市原州区": {
            id: '101170401',
        }, "固原市西吉县": {
            id: '101170402',
        }, "固原市隆德县": {
            id: '101170403',
        }, "固原市泾源县": {
            id: '101170404',
        }, "固原市彭阳县": {
            id: '101170406',
        }, "中卫市沙坡头区": {
            id: '101170501',
        }, "中卫市中宁县": {
            id: '101170502',
        }, "中卫市海原县": {
            id: '101170504',
        },
    },
};
/* ↑↑↑↑↑↑  APP配置信息  ↑↑↑↑↑↑*/
