/* ↓↓↓↓   网络配置信息  ↓↓↓↓*/
var global = {
    ip: appConfig.net.ip,
    port: appConfig.net.port,//端口号
    timeout: appConfig.net.timeout,//超时时间
    prefix: appConfig.net.prefix,//前缀
    suffix: appConfig.isCrossDomain ? appConfig.net.suffixJsonp : appConfig.net.suffix,//后缀

};

/* ↑↑↑↑↑↑  网络配置信息  ↑↑↑↑↑↑*/


/**
 *  RSA加密封装类
 */

var rsaWrapper = function (options) {
    this.options = options;
};

function guid() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

rsaWrapper.defaultOptions = {
    pubk: 'MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCStL+hc+wqxlNmTWEy/g+P8SIRP9xL4MN8n8bqJudlHbNuGnHIeJwtrxi5TJgJ/Msrn/omA7udBGVeP3unhuFxtKDduHFgQjmMqGNpcIqR4EruR+y4KUnnRJ+o44x19fIjKTt0YSX+fK77LKkSjf6gQfn9FyGtPeYBAlBhNjL8WQIDAQAB'
};

rsaWrapper.prototype = {
    render: function () {
        this.options = $.extend({}, rsaWrapper.defaultOptions, this.options);
        var encryptInstance = new JSEncrypt();
        this.options.encryptInstance = encryptInstance;
        encryptInstance.setPublicKey(this.options.pubk);
        return this;
    },

    rsaEncrypt: function (srcText) {
        return this.options.encryptInstance.encryptLong(encodeURI(srcText).replace(/\+/g, '%2B'));
    }
};

var aesUtil = {
    aesKey: 'abcdefgabcdefg12',
    aesEncrypt: function (src) {
        var key = CryptoJS.enc.Utf8.parse(this.aesKey);
        var srcs = CryptoJS.enc.Utf8.parse(src);
        var encrypted = CryptoJS.AES.encrypt(srcs, key, {
            mode: CryptoJS.mode.ECB,
            padding: CryptoJS.pad.Pkcs7
        });
        return encrypted.toString();
    }
};

/**
 *  kit核心类
 *
 */
var kit = {
    /**
     *  rsa加密
     */
    rsaEncrypt: function (srcText, options) {
        options = options || {};
        return new rsaWrapper(options).render().rsaEncrypt(srcText);
    },

    aesEncrypt: function (srcText) {
        return aesUtil.aesEncrypt(srcText);
    },
    generateEncyptParams: function (data) {
        var sep = "θ";
        data['sequence'] = kit.md5(aesUtil.aesKey + guid());
        var paramSrc = kit.toJSON(data);
        //var paramMi = kit.rsaEncrypt(paramSrc);
        var paramMi = kit.aesEncrypt(paramSrc);
        var timestamp = new Date().getTime();
        var echostr = Math.random() + "";
        var signature = kit.md5(paramMi + sep + timestamp + sep + echostr + sep + aesUtil.aesKey);
        return {
            params: paramMi,
            timestamp: timestamp,
            echostr: echostr,
            signature: signature
        };
    },


    md5: function (str) {
        return MD5(str);
    },

    /**
     * 对象转换为JSON 字符串
     *
     * @param anyObject
     * @returns
     */
    toJSON: function (anyObject) {
        return JSON.stringify(anyObject);
    },

    /**
     * JSON字符串转换为对象
     *
     * @param jsonString
     */
    parseJSON: function (jsonString) {
        return JSON.parse(jsonString);
    },

    /**  */
    API_SERVICE_URL: global.ip + ":" + global.port + global.prefix + global.suffix,

    //上传地址
    UPLOAD_URI: global.ip + ":" + global.port + global.prefix + "/api/upload",

    /**
     * 统一上传方法
     * @param {Object} data
     * @param {Object} callback
     */
    uploadFunction: function (data, callback) {
        if (typeof data === 'function') {
            var tmp = callback;
            callback = data;
            data = {};
        }
        // data["token"] = User.getToken(); //从localStroge中获取
        data["token"] = newUser.getToken() || ''; //从localStroge中获取
        //data["token"] = $api.getStorage("token"); //从localStroge中获取
        // console.log("=="+kit.toJSON(data));
        this.postUpload(this.UPLOAD_URI, data, callback);
    },

    /**
     *  post请求
     *
     */
    postUpload: function (url, data, callback) {
        /*var url = this.API_SERVICE_URL + uri;*/
        var ddd = {
            files: {
                "files": data.files
            },
            values: {
                fileType: data.fileType,
                token: data.token
            }
        };
        console.log(url + "===>" + JSON.stringify(ddd));
        //显示loading框
        /*loading();*/
        // 提交JSON数据
        api.ajax({
            url: url,
            method: 'post',
            dataType: 'json',
            returnAll: false,
            timeout: global.timeout,
            data: ddd
        }, function (ret, err) {
            if (ret) {
                callback(ret);
            } else {
                /*if(ApiConstants.PRODUCT_MODE === true) {
                    api.alert({ msg: ApiConstants.PRODUCT_API_ERROR_MSG });
                } else {
                    api.alert({ msg: JSON.stringify(err) });
                }*/
            }
            /* toast.hide();*///隐藏loading框
        });

    },

    /**
     * 请求后台接口
     *
     * @param {Object} sid
     * @param {Object} data
     * @param {Object} callback
     */
    post: function (sid, data, callback) {
        var _this = this;

        if (
            !data &&
            (this._par == JSON.stringify(data) &&
                JSON.stringify(data) != '{}')
        ) {
            return;
        }

        this._par = JSON.stringify(data);

        setTimeout(function () {
            _this._par = null;
        }, 500);

        if (typeof data === 'function') {
            var tmp = callback;
            callback = data;
            data = {};
        }
        //随机四位数
        var code = Math.floor(Math.random() * 9000) + 1000;
        //data["token"] = $api.getStorage("token"); //从localStroge中获取
        // data["token"] = User.getToken(); //从localStroge中获取
        if (newUser.getUserType() === 'dz') {
            // console.log("dz")
            data["token"] = '';
        } else {
            // console.log("nodz")

            data["token"] = newUser.getToken(); //从localStroge中获取
        }



        var requestParams = {
            "SID": sid,
            "PARAMS": data,
            "REQID": code
        };

        console.log('************************** 请求参数 ***************************');
        console.log(JSON.stringify(requestParams));
        console.log('************************** 请求参数 ***************************');

        this.postUrl(this.API_SERVICE_URL, requestParams, function (ret, err) {
            // console.log('************************** 请求参数 ***************************');
            // console.log(JSON.stringify(ret));
            // console.log('************************** 请求参数 ***************************');
            if (ret.STATUS == 0) {
                callback(ret.RESULT);
            } else {
                console.log(JSON.stringify(ret));
                console.log('请求未成功')
                if (ret == null || ret == '') {
                    alert("服务器连接失败，请联系管理员");
                } else if (ret.ERROR.EXCODE == 'INVALID_TOKEN') {

                    console.log("身份过期，请重新登录！ ");
                    //User.clear();
                    newUser.clear();
                    apiModelStore.apiOpenWin("login", false);
                } else if (ret.ERROR.EXCODE == 'INVALID_REQUEST_PARAMS') {
                    var paramkey = ret.ERROR.EXMSG.split('-');
                    if (paramkey.length > 1) {
                        var ele = $('[name=' + paramkey[1] + ']');
                        if (ele.length > 0) {
                            console.log(paramkey[1]);
                            // alert(ele.attr("cname") + "是必填项，不能为空。");
                            apiModelStore.apiToast(ele.attr("cname") + "是必填项，不能为空。");
                        } else {
                            // alert("请求参数错误，请联系管理员");
                            apiModelStore.apiToast("请求参数错误，请联系管理员");
                        }
                    } else {
                        // alert("请求参数错误，请联系管理员");
                        apiModelStore.apiToast("请求参数错误，请联系管理员");
                    }
                } else {
                    apiModelStore.apiToast(ret.ERROR.EXMSG);
                    // alert(ret.ERROR.EXMSG);
                }
            }
        });
    },

    /**
     * 包装jquery的$.post函数，加入错误提示
     *
     * @param url
     * @param data
     * @param callback
     */
    postUrl: function (url, data, callback) {
        if (typeof data === 'function') {
            var tmp = callback;
            callback = data;
            data = {};
        }

        if (appConfig.isCrossDomain) {
            var ssfs = this.generateEncyptParams(data);


            console.log("generateEncyptParams   加密=" + JSON.stringify(ssfs));
            console.log(ssfs);


            console.log("postUrl" + JSON.stringify(data));

            console.log(new Date() + "==url==" + url);
            $.ajax({
                url: url,
                type: "get",
                data: ssfs,
                // data: {values: this.generateEncyptParams(data)},
                dataType: "jsonp",
                //contentType: "application/json",
                contentType: "application/json;charset=UTF-8",
                jsonp: "callback",//传递给请求处理程序或页面的，用以获得jsonp回调函数名的参数名(一般默认为:callback)
                // jsonp: "jsonpService",//传递给请求处理程序或页面的，用以获得jsonp回调函数名的参数名(一般默认为:callback)
                //jsonpCallback:"callback",//自定义的jsonp回调函数名称，默认为jQuery自动生成的随机函数名，也可以写"?"，jQuery会自动为你处理数据
                success: function (data) {
                    callback(data)
                    console.log(JSON.stringify(data));
                },
                error: function () {
                    console.log("请求失败")
                },
            });
        } else {
            api.ajax({
                url: url,
                method: 'post',
                timeout: global.timeout,
                data: {
                    values: this.generateEncyptParams(data)
                }
            }, function (ret, err) {
                callback(ret, err);
                //toast.hide();//隐藏loading框
            });
        }

    },

    /**
     * 包装jquery的$.post函数，加入错误提示
     *
     * @param url
     * @param data
     * @param callback
     *
     * 同步方法
     */

    postSync: function (url, data, callback) {
        if (typeof data === 'function') {
            var tmp = callback;
            callback = data;
            data = tmp;
        }
        api.ajax({
            url: url,
            data: this.generateEncyptParams(data),
            async: false,
            success: function (ret) {
                if (ret.STATUS == 1) {
                    var err = ret.ERROR.EXCODE;
                    if ('INVALID_TOKEN' == err) {
                        getToken();
                    }
                }
                callback(ret);
            },
            type: 'POST',
            dataType: 'json',
            error: function (xhr) {

            }
        });

    },

    /**
     * 数据校验
     * type: 校验类型
     * val: 被校验数据
     */
    check: function (type, val) {
        if (type == 'idCard') {
            return kit.checkIdCard(val);
        } else if (type == 'phone') {
            return kit.checkPhone(val);
        } else {
            return {
                pass: true,
                tip: ''
            };
        }
    },

    /**
     * 校验手机号
     * @param {*} phone
     */
    checkPhone: function (phone) {
        var myreg = /^[1][3,4,5,7,8][0-9]{9}$/;
        var pass = null, tip = '';
        if (!myreg.test(phone)) {
            pass = false;
            tip = '手机号错误';
        } else {
            pass = true;
        }
        return {
            pass: pass,
            tip: tip
        };
    },

    /**
     * 校验身份证
     */
    checkIdCard: function (code) {
        var city = { 11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古", 21: "辽宁", 22: "吉林", 23: "黑龙江 ", 31: "上海", 32: "江苏", 33: "浙江", 34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南", 42: "湖北 ", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆", 51: "四川", 52: "贵州", 53: "云南", 54: "西藏 ", 61: "陕西", 62: "甘肃", 63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门", 91: "国外 " };
        var tip = "";
        var pass = true;
        //验证身份证格式（6个地区编码，8位出生日期，3位顺序号，1位校验位）
        if (!code || !/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i.test(code)) {
            tip = "身份证号格式错误";
            pass = false;
        }

        else if (!city[code.substr(0, 2)]) {
            tip = "身份证地址编码错误";
            pass = false;
        }
        else {
            //18位身份证需要验证最后一位校验位
            // if (code.length == 18) {
            //     code = code.split('');
            //     //∑(ai×Wi)(mod 11)
            //     //加权因子
            //     var factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
            //     //校验位
            //     var parity = [1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2];
            //     var sum = 0;
            //     var ai = 0;
            //     var wi = 0;
            //     for (var i = 0; i < 17; i++) {
            //         ai = code[i];
            //         wi = factor[i];
            //         sum += ai * wi;
            //     }
            //     var last = parity[sum % 11];
            //     if (parity[sum % 11] != code[17]) {
            //         tip = "身份证校验位错误";
            //         pass = false;
            //     }
            // }
        }
        return {
            pass: pass,
            tip: tip
        };
    },

    showFile: function (url) {
        if ($('#file_show').length > 0) {
            return;
        }
        var showVide = false;
        if (
            url.indexOf('.mp4') != -1 ||
            url.indexOf('.MP4') != -1 ||
            url.indexOf('.ogg') != -1 ||
            url.indexOf('.avi') != -1
        ) {
            showVide = true;
        }

        console.log(url);
        console.log(showVide);

        var html = [
            '<div id="file_show">',
            '<span data-close onclick="kit.closeFile()">X</span>',
            showVide ? '' : ('<img src="' + url + '" alt="" srcset="">'),
            showVide ? ('<video autoplay controls src="' + url + '">') : '',
            showVide ? '您的手机系统偏低, 暂不支持视频播放' : '',
            showVide ? '</video>' : '',
            '</div>'
        ].join('');

        $('body').append(html);
    },
    closeFile: function () {
        $('#file_show').remove();
    }

};